#include "CEvalExpression.h"

#include <string.h>
#include <ctype.h>

#define _USE_MATH_DEFINES
#include <math.h>

using namespace std;

CEvalExpression::CEvalExpression()
: ConstCount(0) , VariableCount(0) , FunctionCount(0)
{
	Expression = new char[250];

	SetTables("pi",ConstTable,&ConstCount);
	SetTables("e",ConstTable,&ConstCount);

	SetTables("sin",FunctionTable,&FunctionCount);
	SetTables("cos",FunctionTable,&FunctionCount);
	SetTables("tan",FunctionTable,&FunctionCount);
	SetTables("log",FunctionTable,&FunctionCount);
	SetTables("log10",FunctionTable,&FunctionCount);
	SetTables("abs",FunctionTable,&FunctionCount);
	SetTables("sqrt",FunctionTable,&FunctionCount);
	SetTables("rad2deg",FunctionTable,&FunctionCount);
	SetTables("deg2rad",FunctionTable,&FunctionCount);

	SetTables("integral",FunctionTable,&FunctionCount);
	SetTables("set",FunctionTable,&FunctionCount);
	SetTables("sigma",FunctionTable,&FunctionCount);
}

CEvalExpression::~CEvalExpression()
{
	delete [] Expression;

	for(int i = 0 ; i < ConstCount ; i++)
	{
		delete[] ConstTable[i];
	}

	for(int i = 0 ; i < VariableCount ; i++)
	{
		delete[] VariableTable[i];
	}

	for(int i = 0 ; i < FunctionCount ; i++)
	{
		delete[] FunctionTable[i];
	}
}

double CEvalExpression::Eval(char *Expression)
{
	strcpy(this->Expression,Expression);
	ExpressionLength = strlen(Expression);
	Index = 0;

	double Ret = 0;
	Ret = Func2();
	return Ret;
}

double CEvalExpression::Func1()
{
	return Func2();
}

double CEvalExpression::Func2()
{
	double Ret = Func3();

	while(1)
	{
		if(Expression[Index] == '+')
		{
			Index++;
			Ret += Func3();
		}else if(Expression[Index] == '-')
		{
			Index++;
			Ret -= Func3();
		}else if(Expression[Index] == ' ')
		{
			Index++;
		}else{
			break;
		}
	}

	return Ret;
}

double CEvalExpression::Func3()
{
	double Ret = Func4();

	while(1)
	{
		if(Expression[Index] == '*')
		{
			Index++;
			Ret *= Func4();
		}else if(Expression[Index] == '/')
		{
			Index++;
			double Ret2 = Func4();

			if(Ret2 == 0)
			{
				throw "Can't divide by 0.";
			}

			Ret /= Ret2;
		}else if(Expression[Index] == ' ')
		{
			Index++;
		}else{
			break;
		}
	}

	return Ret;
}

double CEvalExpression::Func4()
{
	double Ret = Func5();

	while(1)
	{
		if(Expression[Index] == '^')
		{
			Index++;
			double Ret2 = Func5();

			Ret = pow(Ret,Ret2);
		}else if(Expression[Index] == ' ')
		{
			Index++;
		}else{
			break;
		}
	}

	return Ret;
}

double CEvalExpression::Func5()
{
	while(1)
	{
		if(Expression[Index] != ' ')
		{
			if(Expression[Index] == '-')
			{
				Index++;
				return -Func6();
			}else{
				return Func6();
			}
		}

		Index++;
	}
}

double CEvalExpression::Func6()
{
	while(1)
	{
		if(Index >= ExpressionLength)
		{
			throw "Func6 Error : Parse Error.";
		}

		if(isdigit(Expression[Index]))
		{
		// ̏ꍇ
			char c[20] = "";
			do
			{
				char c2[2] = {Expression[Index],'\0'};
				strcat(c,c2);
				Index++;
			}
			while(isdigit(Expression[Index]) || Expression[Index] == '.');

			return atof(c);
		}else if(Expression[Index] == '(')
		{
		// ʂ̏ꍇ
			Index++;
			double Ret = Func1();

			// 󔒂̕Oɐi߂
			while(Expression[Index] == ' ')
			{
				Index++;
			}

			if(Expression[Index] != ')')
			{
				throw "Func6 Error : ) has not been closed.";
			}else{
				Index++;
			}

			return Ret;
		}
		else if(isalnum(Expression[Index]))
		{
		// p̏ꍇ
			char Name[64] = "";
			int Pos = 0;

			do
			{
				Name[Pos] = Expression[Index];
				Index++;
				Pos++;
			}
			while(isalnum(Expression[Index]));

			// 萔e[ũ`FbN
			if(TableCheck(Name,ConstTable,ConstCount))
			{
				return Const(Name);
			}
			// ϐe[ũ`FbN
			if(TableCheck(Name,VariableTable,VariableCount))
			{
				return Variable(Name);
			}
			// ֐e[ũ`FbN
			if(TableCheck(Name,FunctionTable,FunctionCount))
			{
				return Function(Name);
			}

			throw "Func6 Error : Wrong character.";
		}else if(Expression[Index] == ' ')
		{
			Index++;
		}else{
			throw "Func6 Error : Parse Error.";
		}
	}
}

bool CEvalExpression::TableCheck(char* Name,char** Table,int ArrayLength)
{
	for(int i = 0 ; i < ArrayLength ; i++)
	{
		if(strcmp(Name,Table[i]) == 0)
		{
			return true;
		}
	}

	return false;
}

void CEvalExpression::SetTables(char* Name,char** Tables,int* Count)
{
	Tables[*Count] = new char[250];
	strcpy(Tables[*Count],Name);
	(*Count)++;
}

void CEvalExpression::SetVariable(char* Name,double Value)
{
	for(int i = 0 ; i < VariableCount ; i++)
	{
		if(strcmp(VariableTable[i],Name) == 0)
		{
			VariableValue[i] = Value;
			return;
		}
	}

	// Ȃꍇ
	VariableTable[VariableCount] = new char[250];
	strcpy(VariableTable[VariableCount],Name);
	VariableValue[VariableCount] = Value;
	VariableCount++;
}

double CEvalExpression::Const(char* Name)
{
	if(strcmp(Name,"e") == 0)
	{
		return M_E;
	}

	if(strcmp(Name,"pi") == 0)
	{
		return M_PI;
	}

	throw "Const Fatal Error : Registered in ConstTable. But, not implement.";
}

double CEvalExpression::Variable(char* Name)
{
	int count = -1;
	// ϐ̓Y𐔂

	for(count = 0 ; count < VariableCount ; count++)
	{
		if(strcmp(VariableTable[count],Name) == 0)
		{
			break;
		}
	}

	if(count == -1)
	{
		throw "Variable Error : Variable not found.";
	}

	return VariableValue[count];
}

double CEvalExpression::Function(char* Name)
{
	double Ret = 0;

	// ɋ󔒂͐̕i߂Ă
	while(Expression[Index] == ' ')
	{
		Index++;
	}

	if(strcmp(Name,"sin") == 0)
	{
		double Ret2 = Func1();
		Ret = sin(Ret2);
	}else if(strcmp(Name,"cos") == 0)
	{
		double Ret2 = Func1();
		Ret = cos(Ret2);
	}else if(strcmp(Name,"tan") == 0)
	{
		double Ret2 = Func1();
		Ret = tan(Ret2);
	}else if(strcmp(Name,"log") == 0)
	{
		double Ret2 = Func1();
		Ret = log(Ret2);
	}else if(strcmp(Name,"log10") == 0)
	{
		double Ret2 = Func1();
		Ret = log10(Ret2);
	}else if(strcmp(Name,"abs") == 0)
	{
		double Ret2 = Func1();
		Ret = abs(Ret2);
	}else if(strcmp(Name,"sqrt") == 0)
	{
		double Ret2 = Func1();
		if(Ret2 < 0)
		{
			if(-0.0000001 < Ret2)
			{
				Ret2 = 0;
			}else{
				throw "Function Error : sqrt(x) is defined x >= 0.";
			}
		}
		Ret = sqrt(Ret2);
	}else if(strcmp(Name,"rad2deg") == 0)
	{
		double Ret2 = Func1();
		Ret = (Ret2 * 180.0) / M_PI;
	}else if(strcmp(Name,"deg2rad") == 0)
	{
		double Ret2 = Func1();
		Ret = (Ret2 * M_PI) / 180.0;
	}
	
	// ȉAȎ
	else if(strcmp(Name,"set") == 0)
	{
		char Temp[250] = "";

		// ϐ
		char Arg1[250] = "";
		SplitArguments(Temp,&Expression[Index],0);
		Trim(Arg1,Temp);

		// l
		char Arg2[250] = "";
		SplitArguments(Arg2,&Expression[Index],1);

		double Value = 0;
		CEvalExpression* eval = new CEvalExpression();
		Value = EvalAnotherExpression(Arg2);
		SetVariable(Arg1,Value);

		// set̖߂ln
		Ret = Value;

		// ŌɁAIndex̒lς
		Index += GetEndArgumentsLength(&Expression[Index]) + 1;
	}else if(strcmp(Name,"integral") == 0)
	{
		int count = 0;
		int head = Index;
		char Temp[250] = "";

		// ϕϐ
		char Arg1[250] = "";
		SplitArguments(Temp,&Expression[Index],0);
		Trim(Arg1,Temp);

		// ϕԂ̉
		char Arg2[250] = "";
		double Arg2Value = 0;
		SplitArguments(Arg2,&Expression[Index],1);
		Arg2Value = EvalAnotherExpression(Arg2);

		// ϕԂ̏
		char Arg3[250] = "";
		double Arg3Value = 0;
		SplitArguments(Arg3,&Expression[Index],2);
		Arg3Value = EvalAnotherExpression(Arg3);

		// x
		char Arg4[250] = "";
		SplitArguments(Temp,&Expression[Index],3);
		Trim(Arg4,Temp);

		// ϕ֐
		char Arg5[250] = "";
		SplitArguments(Arg5,&Expression[Index],4);

		double p = atoi(Arg4);	// x
		double Delta = (Arg3Value - Arg2Value) / p;

		// ϕ
		for(int x = 0 ; x < p ; x++)
		{
			CEvalExpression* eval = new CEvalExpression();
			CopyVariable(eval);

			// ߎl̑
			double Value = Arg2Value + Delta * x;
			eval->SetVariable(Arg1,Value);

			try
			{
				Ret += (eval->Eval(Arg5)) * Delta;
			}catch(char* Error)
			{
				cout << "Function Error : Wrong define in \"function\"." << endl;
				cout << "> " << Error << endl;
			}

			delete eval;
		}

		Index += GetEndArgumentsLength(&Expression[Index]) + 1;
	}else if(strcmp(Name,"sigma") == 0)
	{
		char Temp[250] = "";

		// Ώۂ̕ϐ
		char Arg1[250] = "";
		SplitArguments(Temp,&Expression[Index],0);
		Trim(Arg1,Temp);

		// Jnl
		char Arg2[250] = "";
		int Arg2Value = 0;
		SplitArguments(Arg2,&Expression[Index],1);
		Arg2Value = EvalAnotherExpression(Arg2);

		// Il
		char Arg3[250] = "";
		int Arg3Value = 0;
		SplitArguments(Arg3,&Expression[Index],2);
		Arg3Value = EvalAnotherExpression(Arg3);

		// 
		char Arg4[250] = "";
		SplitArguments(Arg4,&Expression[Index],3);

		// a߂
		for(int i = Arg2Value ; i <= Arg3Value ; i++)
		{
			CEvalExpression* eval = new CEvalExpression();
			CopyVariable(eval);

			// ߎl̑
			eval->SetVariable(Arg1,i);

			try
			{
				Ret += eval->Eval(Arg4);
			}catch(char* Error)
			{
				cout << "Function Error : Wrong define in \"function\"." << endl;
				cout << "> " << Error << endl;
			}

			delete eval;
		}

		Index += GetEndArgumentsLength(&Expression[Index]) + 1;
	}else{
		throw "Function Fatal Error : Registered in FunctionTable. But, not implement.";
	}

	return Ret;
}

void CEvalExpression::SplitArguments(char* Dest,char* Src,int Number)
{
	int head = 0;
	int count = 0;
	int arg_count = 0;
	char Arguments[250] = "";

	// o

	// ܂AJnT
	while(1)
	{
		if(Src[head] == '(')
		{
			head++;
			break;
		}

		head++;
	}

	// ɁAIT
	int Depth = 1;

	while(1)
	{
		// ꃌx̊ʂ̂݃p[X
		if(Src[head + count] == '(')
		{
			Depth++;
		}

		if(Src[head + count] == ')' && Depth == 1)
		{
			break;
		}

		if(Src[head + count] == ')' && Depth != 1)
		{
			Depth--;
		}

		count++;
	}

	strncpy(Arguments,&Src[head],count);

	// u,vŕ
	head = 0;
	count = 0;
	Depth = 0;

	while(1)
	{
		// ꃌx̊ʂ̂݃p[X
		if(Arguments[head + count] == '(')
		{
			Depth++;
		}
		if(Arguments[head + count] == ')')
		{
			Depth--;
		}

		if(Arguments[head + count] == ',' && Depth == 0)
		{
			// 擾ꍇ
			if(arg_count == Number)
			{
				strncpy(Dest,&Arguments[head],count);
				return;
			}

			arg_count++;
			head += count + 1;
			count = 0;
		}

		if(Arguments[head + count] == '\0')
		{
			// 擾ꍇ
			if(arg_count == Number)
			{
				strncpy(Dest,&Arguments[head],count);
				return;
			}else{
				throw "SplitArguments Error : There are not enough arguments.";
			}
		}

		count++;
	}
}

void CEvalExpression::Trim(char* Dest,char* Src)
{
	int head = 0;
	int count = 0;

	// ŏ̕܂łƂ΂
	while(1)
	{
		if(Src[head] != ' ')
		{
			break;
		}

		head++;
	}

	// 󔒂̒OÁAI[T
	while(1)
	{
		if(Src[head + count] == ' ' || Src[head + count] == '\0')
		{
			break;
		}

		count++;
	}

	strncpy(Dest,&Src[head],count);
}

void CEvalExpression::CopyVariable(CEvalExpression *Dest)
{
	// ϐe[ũRs[
	for(int i = 0 ; i < VariableCount ; i++)
	{
		Dest->SetVariable(VariableTable[i],VariableValue[i]);
	}
}

double CEvalExpression::EvalAnotherExpression(char* Expression)
{
	double Ret = 0;

	CEvalExpression* eval = new CEvalExpression();
	CopyVariable(eval);

	try
	{
		Ret = eval->Eval(Expression);
	}catch(char* Error)
	{
		cout << "Function Error : Wrong define in \"function\"." << endl;
		cout << "> " << Error << endl;
	}

	delete eval;
	return Ret;
}

int CEvalExpression::GetEndArgumentsLength(char *str)
{
	int Length = 0;
	int Depth = 0;

	while(1)
	{
		if(str[Length] == '(')
		{
			Depth++;
		}

		if(str[Length] == ')')
		{
			Depth--;
		}

		if(str[Length] == ')' && Depth == 0)
		{
			break;
		}

		Length++;
	}

	return Length;
}
